/* 
 * Vector addition applet  
   Original java by Julio Gea-Banacloche <jgeabana@uark.edu>
   Modified and extended by Michael Winokur <mwinokur@wisc.edu>
   Source code may be used and distributed without permission 
   if for non-profit purposes.
 */

import java.applet.*;
import java.awt.*;
import java.lang.*;

import java.util.Vector;

public class VectorTest2 extends Applet
{
	DrawingRegion region;
	public void init()
	{
		setBackground(Color.lightGray);
		setLayout(new BorderLayout());
		DrawingRegion region = new DrawingRegion();
		add("Center", region);
		add("South", new myCustomButtons(region));
/*		region = new DrawingRegion();
		add(region);
		add(new myCustomButton(region, "Clear"));
		add(new myCustomButton(region, "Clear All"));
		add(new myCustomButton(region, "Add"));  */
	}
}

class DrawingRegion extends Canvas
{

/*	public DrawingRegion() 
	{ 
		resize(480,400);
		
	}

*/	public int gNvectors = 0;
    public int Flag1 = 0;
    public static final int x0 = 200;
    public static final int y0 = 200;
    public Vector gPoints = new Vector();
	Color gColors[] = {Color.blue, Color.red, Color.green};
    int x1,y1;
    int x2,y2;
    int xl, yl;
    boolean in = false;
    Font boldFont = new Font("Helvetica", Font.BOLD, 10);
    Font plainFont = new Font("Helvetica", Font.PLAIN, 10);
    Font numFont = new Font("Helvetica", Font.PLAIN, 12);
/*    Font numFont = new Font("Symbol", Font.PLAIN, 12); */
	

    public boolean handleEvent(Event e) 
	{
    
	switch (e.id) {
	  case Event.MOUSE_DOWN:
	    if(gNvectors<3)  /*  was 2 */
	    if(e.x<300 && e.y <300 && e.x > 100 && e.y >100)
	    {
		    Graphics g = getGraphics();
			x1 = x0;
			y1 = y0;
			x2 = e.x;
			y2 = e.y;
			g.setColor(Color.black);
			g.setPaintMode();
			drawVector(g, x0, y0, e.x, e.y);
		}
		return true;
	  case Event.MOUSE_UP:
	    if(gNvectors<3)  /*  was 2 */
	    {
		    Graphics g = getGraphics();
		    if(e.x<300 && e.y <300 && e.x > 100 && e.y >100)
		    {
				g.setColor(gColors[gNvectors]);
				gPoints.addElement(new Point(e.x,e.y));
				drawVector(g, x0, y0, e.x, e.y);
				writeCoords(g, gNvectors, e.x, e.y);
				gNvectors++;
		    }
			else if(in == true)
			{
				in = false;
				/* repaint(); */
			}
		}
	    return true;
	  case Event.MOUSE_DRAG:
	    if(gNvectors<3)
	    {
		    if(e.x<300 && e.y <300 && e.x > 100 && e.y >100)
		    {
			    Graphics g = getGraphics();
			    in = true;
				xl = x2;
				yl = y2;
				
				x2 = e.x;
				y2 = e.y;
				g.setColor(Color.black); 
			    g.setXORMode(Color.white);
				drawVector(g, x0, y0, xl, yl);

			    g.setPaintMode();
			    g.setColor(Color.white);
				writeCoords(g,gNvectors, xl,yl);
				g.setColor(gColors[gNvectors]);
			    writeCoords(g,gNvectors, x2,y2); 

				g.setColor(Color.black); 
			    g.setXORMode(Color.white);
				drawVector(g, x0, y0, x2, y2);

			}
		}
	    return true;
	  case Event.WINDOW_DESTROY:
	    System.exit(0);
	    return true;
	  default:
	    return false;
	}
    }
    
    public void drawVector(Graphics g, int x1, int y1, int x2, int y2)
    {
		double theta;
		long x, y;
	
		theta = Math.atan2(y1-y2,x2-x1);
		
		g.drawLine(x1, y1, x2, y2);
		x = Math.round(6*Math.cos(theta+Math.PI/10.));
		y = Math.round(6*Math.sin(theta+Math.PI/10.));
		g.drawLine(x2, y2, x2-(int)x, y2+(int)y);
		x = Math.round(6*Math.cos(theta-Math.PI/10.));
		y = Math.round(6*Math.sin(theta-Math.PI/10.));
		g.drawLine(x2, y2, x2-(int)x, y2+(int)y);
	}
	
	public void paint(Graphics g)
	{
	    g.setPaintMode(); 
		g.setColor(Color.white);
		g.fillRect(0,0,400,400);
		g.setColor(Color.black);
		g.drawRect(0,0,400,400);

		drawGrid(g);
		drawText(g); 


		for (int i = 0; i<gNvectors; i++)
		{
			if(i<3)  /* was 2 */
			{
			 g.setColor(gColors[i]);
			 drawVector(g, x0, y0, ((Point)gPoints.elementAt(i)).x, ((Point)gPoints.elementAt(i)).y);
			 writeCoords(g, i, ((Point)gPoints.elementAt(i)).x, ((Point)gPoints.elementAt(i)).y); 
		 	}  
			/* else drawSum(); */
		}
		if (Flag1==3) {drawSum(0,1);}
		else if (Flag1==4) {drawSum(0,2);}
		else if (Flag1==5) {drawSum(1,2);}
		else if (Flag1==6) {drawSumAll();}
	}
	
	public void clear()
	{
		gNvectors -=1;
		getGraphics().clearRect(404,4+95*3,103,87); 
		if(gNvectors<3) gPoints.removeElement((Point)gPoints.elementAt(gNvectors));
	}   
	
	
	public void drawSum(int f0, int f1)
	{
		int sumx, sumy, i, length1, length2, length3;
		Graphics g = getGraphics();
		getGraphics().clearRect(404,4+95*3,103,87);
		sumx = ((Point)gPoints.elementAt(f0)).x + ((Point)gPoints.elementAt(f1)).x - x0;
		sumy = ((Point)gPoints.elementAt(f0)).y + ((Point)gPoints.elementAt(f1)).y - y0;
		
		g.setColor(Color.yellow);
		drawVector(g, ((Point)gPoints.elementAt(f0)).x, ((Point)gPoints.elementAt(f0)).y, sumx, sumy);
		drawVector(g, ((Point)gPoints.elementAt(f1)).x, ((Point)gPoints.elementAt(f1)).y, sumx, sumy);
		g.setColor(Color.magenta);
		drawVector(g, x0, y0, sumx, sumy);

		g.setColor(Color.black);

	    int voff = 15;
	    
	    g.setPaintMode(); 
		
		g.setColor(Color.white);
		g.fillRect(405,5+95*3,100,85);
		g.setColor(Color.black);
		g.drawRect(405,5+95*3,100,85);
		
		g.setFont(boldFont);
		length1 = g.getFontMetrics().stringWidth("Sum Vector");
		g.drawString("Sum Vector", 405+(100-length1)/2, 5+95*3+voff);
		
		g.setFont(plainFont);
		g.drawString("x component:", 410, 5+95*3+2*voff);
		g.drawString("y component:", 410, 5+95*3+3*voff);
		g.drawString("Magnitude:",   410, 5+95*3+4*voff);
		g.drawString("Direction:",   410, 5+95*3+5*voff);
		
		g.setColor(Color.magenta);
		writeCoords(g, 3, sumx, sumy);
	}
	
	public void drawSumAll()
	{
		int sumx, sumy, sumx2, sumy2, i, length1, length2, length3;
		Graphics g = getGraphics();
		getGraphics().clearRect(404,4+95*3,97,87);
		sumx = ((Point)gPoints.elementAt(0)).x + ((Point)gPoints.elementAt(1)).x - x0;
		sumy = ((Point)gPoints.elementAt(0)).y + ((Point)gPoints.elementAt(1)).y - y0;
		
		g.setColor(Color.yellow);
		drawVector(g, ((Point)gPoints.elementAt(0)).x, ((Point)gPoints.elementAt(0)).y, sumx, sumy);
		drawVector(g, ((Point)gPoints.elementAt(1)).x, ((Point)gPoints.elementAt(1)).y, sumx, sumy);

		g.setColor(Color.magenta);
		drawVector(g, x0, y0, sumx, sumy);
		
		sumx2 = sumx;
		sumy2 = sumy;
		
		
		sumx += ((Point)gPoints.elementAt(2)).x - x0;
		sumy += ((Point)gPoints.elementAt(2)).y - y0;

		g.setColor(Color.cyan);
		drawVector(g, sumx2, sumy2, sumx, sumy);


		g.setColor(Color.black);
		drawVector(g, x0, y0, sumx, sumy);

		g.setColor(Color.black);

	    int voff = 15;
	    
	    g.setPaintMode(); 
		
		g.setColor(Color.white);
		g.fillRect(405,5+95*3,100,85);
		g.setColor(Color.black);
		g.drawRect(405,5+95*3,100,85);
		
		g.setFont(boldFont);
		length1 = g.getFontMetrics().stringWidth("Sum Vector");
		g.drawString("Sum Vector", 405+(100-length1)/2, 5+95*3+voff);
		
		g.setFont(plainFont);
		g.drawString("x component:", 410, 5+95*3+2*voff);
		g.drawString("y component:", 410, 5+95*3+3*voff);
		g.drawString("Magnitude:",   410, 5+95*3+4*voff);
		g.drawString("Direction:",   410, 5+95*3+5*voff);
		
		writeCoords(g, 3, sumx, sumy);
	}
	
	void drawGrid(Graphics g)
	{
		int i;
	
		g.setColor(Color.lightGray);
	
		for(i=1; i<40; i++)
		{
			g.drawLine(10*i,1, 10*i, 399);
			g.drawLine(1,10*i, 399, 10*i);
		}
		
		g.setColor(Color.black);
//draw axes
		g.drawLine(200,0, 200, 399);
		g.drawLine(1,200,400, 200);
//draw tick marks and labels
		g.setFont(numFont);
		g.drawLine(198,100,202,100);
		g.drawString("10",204,105);
		g.drawLine(198,300,202,300);
		g.drawString("-10",204,305);
		g.drawLine(100,198,100,202);
		g.drawString("-10",90,212);
		g.drawLine(300,198,300,202);
		g.drawString("10", 295, 212);
	}
	
	void drawText(Graphics g)
	{
	    int i, length1, length2, length3;
	    int voff = 15;
	    
	    g.setPaintMode(); 
		
		for(i=0;i<3;i++)
		{
			g.setColor(Color.white);
			g.fillRect(405,5+95*i,100,85);
			g.setColor(Color.black);
			g.drawRect(405,5+95*i,100,85);
		}
		
		g.setFont(boldFont);
		length1 = g.getFontMetrics().stringWidth("Vector 1");
		g.drawString("Vector 1", 405+(100-length1)/2, 5+voff);
		length2 = g.getFontMetrics().stringWidth("Vector 2");
		g.drawString("Vector 2", 405+(100-length1)/2, 100+voff);
		length3 = g.getFontMetrics().stringWidth("Vector 3");
		g.drawString("Vector 3", 405+(100-length1)/2, 195+voff);
		
		g.setFont(plainFont);
		for(i=0;i<3;i++)
		{
			g.drawString("x component:", 410, 5+95*i+2*voff);
			g.drawString("y component:", 410, 5+95*i+3*voff);
			g.drawString("Magnitude:",   410, 5+95*i+4*voff);
			g.drawString("Direction:",   410, 5+95*i+5*voff);
		}
		

	}
	
	void writeCoords(Graphics g, int i, int x3, int y3)
	{
		double vx, vy, theta, magn;
		int length;
		String vxstr, vystr, thetastr, magnstr;
		int voff = 15;
		
		vx = (double)((x3-x0)/10.);
		vxstr = Double.toString(vx);
		vy = (double)((y0-y3)/10.);
		vystr = Double.toString(vy);
		theta = Math.atan(Math.abs(((double)(y0-y3))/(x3-x0)))*180/Math.PI;
		theta = Math.round(theta*10)/10.;
		if(y0<y3)
		{
			if (x3>x0) theta = -theta;
			else theta = theta-180;
		}
		else if(x3<x0) theta = 180-theta;
		thetastr = Double.toString(theta);
		magn = (double)(Math.round(10*Math.sqrt(vx*vx+vy*vy))/10.);
		magnstr = Double.toString(magn);
		
		g.setFont(numFont);
		length = g.getFontMetrics().stringWidth(vxstr);
		g.drawString(vxstr,    503-length, 5+95*i+2*voff);
		length = g.getFontMetrics().stringWidth(vystr);
		g.drawString(vystr,    503-length, 5+95*i+3*voff);
		length = g.getFontMetrics().stringWidth(magnstr);
		g.drawString(magnstr,  503-length, 5+95*i+4*voff);
		length = g.getFontMetrics().stringWidth(thetastr);
		g.drawString(thetastr, 503-length, 5+95*i+5*voff);
	}	
	
}
		
class myCustomButtons extends Panel
{
	DrawingRegion target;
	
	public myCustomButtons(DrawingRegion target)
	{
		this.target = target;
		setLayout(new FlowLayout());
		add(new Button("Clear"));
		add(new Button("Clear All"));
		add(new Button("Add 1,2"));
		add(new Button("Add 2,3"));
		add(new Button("Add 1,3"));
		add(new Button("Add 1,2,3"));
	}
	
	public boolean action(Event e, Object label)
	{
		if(target.gNvectors >0) 
		{
			String choice = (String)label;
			target.Flag1=0;
			if(choice.equals("Clear"))
			{	
				target.clear();
				target.repaint();
			}
			else if(choice.equals("Clear All"))
			{
				while(target.gNvectors>0) 
				target.clear();
				target.repaint();
			}
			else if(choice.equals("Add 1,2"))
			{
				if(target.gNvectors > 1) 
				{target.Flag1=3;
				 target.repaint();
				}
			}
			else if(choice.equals("Add 2,3"))
			{
				if(target.gNvectors > 2)
				{target.Flag1=5;
				 target.repaint();
				}
			}
			else if(choice.equals("Add 1,2,3"))
			{
				if(target.gNvectors > 2)
				{target.Flag1=6;
				 target.repaint();
				}
			}
			else if(choice.equals("Add 1,3"))
			{
				if(target.gNvectors > 2)
				{target.Flag1=4;
				 target.repaint();
				}
			}
		}
		return true;
	}
}

